#!/usr/bin/env python3
# -*- coding: utf-8 -*-

"""Norwirin Mapudungun Trapümfe - Web Service - Text Treatment with Regular Expressions

This program is part of "Norwirin Mapudungun Trapümfe" a Mapudungun Orthographic Unifiyer
for a later morphological processing.
Visit http://www.chandia.net/küdawkawe for the version with python.
"""

__author__ = "Andrés Chandía (andres@chandia.net)"
__version__ = "$Revision: 2.7 $"
__date__ = "$Date: 2014-12-09 03:06:26 $"
__copyright__ = "Copyright (c) 2011 Andrés Chandía"
__license__ = "Free"

# import modules to use (cherry python web service, regular expressions, operating system, system)
import cherrypy, re, os, sys

# import the module to enable downloading for the resulting file
from cherrypy.lib.static import serve_download

# 
def Parser(template, params):
	for var in params:
		expr = r"%"+var+"%"
		template = re.sub(expr, params[var], template)
	return template

# define the class that creates the index page 
class indexpage(object):
	def index(self):
		return "NMT"
	index.exposed = True

#
class helloworld(object):
	indexpage = indexpage()
# set the directory where the files are, to use them as resources
	_cp_config = {	'tools.staticdir.on': True,
# set the source directory, i.e. root directory (no trailing backslash)
			'tools.staticdir.root': '/srv/web/NMT',
# set all the dir as resource
			'tools.staticdir.dir': '',
			}

# define the function that loads the index page
	def index(self):

# the html index page
		return """
<!-- the head -->
	<html><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><title>NMT - Norwirin Mapudungun Trap&uuml;mfe</title>
	<script type="text/javascript" src="tinymce/tinymce.min.js"></script>
	
</head>
<!-- the body -->
	<body><h3><a title="Unificador Ortográfico Mapudungun"><font face=sans>Norwirin Mapudungun Trap&uuml;mfe</font></a></h3>
	<p><font face=arial><strong>wirin kam ngülün faw ti dwamün trapümün</strong></font><br><code>Escriba o inserte aquí el texto que desea unificar</code></p>
<!-- the form (textarea) -->
	<form method="POST" action="NMT"><table width=100% bgcolor="white"><tr><td><textarea name="contents" id="contents" style="width:100%;height:300px"></textarea>
	<script type="text/javascript">
      tinyMCE.init({
        theme : "modern",
        theme_modern_toolbar_location : "top",
        theme_modern_toolbar_align : "left",
        menubar : "false",
        mode : "exact",
        language : "es",
        toolbar: "undo redo | underline charmap | cut copy paste | link",
        plugins: "charmap autoresize autolink link",
        autoresize_min_height: "200",
        autoresize_max_height: "500",
        custom_undo_redo_levels: "18",
        elements : "contents",
      });
      </script></td></tr></table>
<!-- the submit button and the end of the page -->
	<a title="unificar"><input type="submit" value=" trapümün " /></a></form></body></html>"""

#define form function
	def NMT(self, contents=None):
		if not contents:
			return """<html><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><title>NMT - Norwirin Mapudungun Trap&uuml;mfe</title></head>
					<body><font face=arial>Inserte el texto para unificar<br><a href=.>Inténtelo de nuevo</a></fon></body></html>"""
				  
		else:

# regular expressions: 
# dealing with some html code
# convert underlined characters into the apostrophée form
			contents = re.sub(r'(<u>|<span style="text-decoration: underline;">)(l|L|n|N|t|T)(</span>|</u>)', r"\2'" ,contents)
# convert html lines brakes into text line brake
			contents = re.sub(r'<([B|b][R|r][ /]?)>', "\n", contents)
# delete all html tags
			contents = re.sub(r'<.*?>', "", contents)
# convert html spaces into text spaces
			contents = re.sub(r'&nbsp;', " ", contents)

# errors comming from spanish orthography
# no orthographic representation for accents in mapudungun
#1                      contents = re.sub(r'Á', "A", contents)
#1                      contents = re.sub(r'á', "a", contents)
			contents = re.sub(r'Á|á|&aacute;|&Aacute;', "a", contents)
#1                      contents = re.sub(r'É', "E", contents)
#1                      contents = re.sub(r'é', "e", contents)
			contents = re.sub(r'É|é|&eacute;|&Eacute;', "e", contents)
#1                      contents = re.sub(r'Í', "I", contents)
#1                      contents = re.sub(r'í', "i", contents)
			contents = re.sub(r'Í|í|&iacute;|&Iacute;', "i", contents)
#1                      contents = re.sub(r'Ó', "O", contents)
#1                      contents = re.sub(r'ó', "o", contents)
			contents = re.sub(r'Ó|ó|&oacute;|&Oacute;', "o", contents)
#1                      contents = re.sub(r'Ú', "U", contents)
#1                      contents = re.sub(r'ú', "u", contents)
			contents = re.sub(r'Ú|ú|&uacute;|&Uacute;', "u", contents)


# transformation rules
# dealing with character conversion 
# vowels
#1			contents = re.sub(r'ə|ï|v', "ü" ,contents)
#1			contents = re.sub(r'Ï|V', "Ü" ,contents)
			contents = re.sub(r'ə|ï|v|Ï|V', 'ü' ,contents)
			contents = re.sub(r'&iuml;|&Iuml;|&uuml;|&iUml;', 'ü' ,contents)
# glides
# never found on boundaries
			contents = re.sub(r'(.)q', r"\1g" ,contents)
# consonants
# a "c" that is not followed by an "h" is converted into "ch"
#1			contents = re.sub(r'(C|c)([^h])', r"\1h\2" ,contents)
			contents = re.sub(r'(C|c)([^h])', r"ch\2" ,contents)
			contents = re.sub(r'&ntilde;|&Ntilde;', 'ñ' ,contents)
#1			contents = re.sub(r'Sd|Z', "D" ,contents)
#1			contents = re.sub(r'sd|z', "d" ,contents)
			contents = re.sub(r'(S|s)d|z|Z', "d" ,contents)
#1			contents = re.sub(r'L(·|d|h)|B', r"L'" ,contents)
#1			contents = re.sub(r'l(·|d|h)|b', r"l'" ,contents)
			contents = re.sub(r'(L|l)(·|d|h)|b|B', r"l'" ,contents)
#1			contents = re.sub(r'J', "Ll" ,contents)
#1			contents = re.sub(r'j', "ll" ,contents)
			contents = re.sub(r'j|J', "ll" ,contents)
#1			contents = re.sub(r'N(·|d|h)|H', r"N'" ,contents)
#1			contents = re.sub(r'(n|T|t)(·|d|h)', r"\1'" ,contents)
			contents = re.sub(r'(n|N)(·|d|h)', r"n'" ,contents)
			contents = re.sub(r'(T|t)(·|d|h)', r"t'" ,contents)
# an "h" that is not preceded by a "c" or an "n" is converted into an "n'"
#1			contents = re.sub(r'([^(C|c|N|n)])h', r"\1n'" ,contents)
			contents = re.sub(r'([^(C|c|N|n)])(H|h)', r"\1n'" ,contents)
			contents = re.sub(r'&#331;|ŋ', "ng" ,contents)
#1			contents = re.sub(r'(\b)G', r"\1Ng" ,contents)
#1			contents = re.sub(r'(\b)g', r"\1ng" ,contents)
			contents = re.sub(r'(\b)(g|G)', r"\1ng" ,contents)
#1			contents = re.sub(r'(T|t)x', r"\1r" ,contents)
#1			contents = re.sub(r'X', "Tr" ,contents)
#1			contents = re.sub(r'x', "tr" ,contents)
			contents = re.sub(r'(T|t)x|X|x', r"tr" ,contents)
			contents = re.sub(r'ʃ', "sh" ,contents)

# orthographic corrections
# diphthongs are disabled because of lack of information
# dealing with diphthongs
#			contents = re.sub(r'(A|a|E|e|O|o|U|u|Ü|ü)i', r"\1y" ,contents)
#			contents = re.sub(r'(A|a|E|e)(o|u)', r"\1w" ,contents)
#			contents = re.sub(r'I(a|e|o|u|w)', r"Y\1" ,contents)
# the diphthong do not applies when followed by an "a" or "e"
#			contents = re.sub(r'i(a|e|o|u|w)([^a]|[^e])', r"y\1\2" ,contents)
#			contents = re.sub(r'(O|U|Wu)(a|e|o)', r"W\2" ,contents)
#			contents = re.sub(r'(o|u)(a|e|o)', r"w\2" ,contents)
#			contents = re.sub(r'(O|o)u', r"\1w" ,contents)

# adjusting the output
# delete blank spaces at the beggining or end of lines
			contents = re.sub(r'^\s+|\n\s+|\s+$', "" ,contents)
# convert multiple consecutive line brakes into only one
			contents = re.sub(r'(\n[\r]?)+', "\n", contents)

# open (or create) the destination file
		with open("nmt.txt","w") as fileout:
# write all the changes into the destination file
			fileout.write(contents)

# the result html page
		return """
<!-- the head -->
	<html><head><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" /><title>NMT - Norwirin Mapudungun Trap&uuml;mfe</title></head>
<!-- the body -->
	<body><h3><font face=sans><a title="Unificador Ortográfico Mapudungun">Norwirin Mapudungun Trapümfe</a></font></h3>
	<strong><font face=arial>Los datos se porcesaron correctamente</font></strong><br><code>Puede descargarlos con el botón que hay bajo la ventana de texto</code><br /><br />
<!-- expose the resulting file by web --><table width=100% bgcolor="white"><tr><td>
	<iframe src="nmt.txt" width="100%" height="300" scrolling="auto" frameborder="2"></iframe></td></tr></table>
<!-- give options -->
	<table><tr>
	<td><form action=.><a title="otra vez"><input type="submit" value=" welün " /></a></form></td>
	<td><form action="download"><a title="descargar"><input type="submit" value=" entun " /></a></form></td>
	</tr></table>
<!-- close the html file -->
	</body></html>"""

# define the downloading funtcion
	def download(self):
        	return serve_download('/srv/web/NMT/nmt.txt')
	download.exposed = True

# expose the text area
	NMT.exposed = True

# expose the index, otherwise won't be shown
	index.exposed = True

# set service port, to not conflict with other services
cherrypy.config.update({'server.socket_host': '0.0.0.0',
                         'server.socket_port': 8080,
                        }) 

# web server engine, http://www.chandia.net:8080
cherrypy.quickstart(helloworld())


